const char * lj_sdk = 

"#if defined(NV_KERNEL) || defined(USE_HIP)\n"
"#include \"lal_pre_cuda_hip.h\"\n"
"#endif\n"
"#if !defined(NV_KERNEL) && !defined(USE_HIP)\n"
"#define USE_OPENCL\n"
"#if (__OPENCL_VERSION__ > 199)\n"
"#define NOUNROLL __attribute__((opencl_unroll_hint(1)))\n"
"#else\n"
"#define NOUNROLL\n"
"#endif\n"
"#define GLOBAL_ID_X get_global_id(0)\n"
"#define THREAD_ID_X get_local_id(0)\n"
"#define BLOCK_ID_X get_group_id(0)\n"
"#define BLOCK_SIZE_X get_local_size(0)\n"
"#define GLOBAL_SIZE_X get_global_size(0)\n"
"#define THREAD_ID_Y get_local_id(1)\n"
"#define BLOCK_ID_Y get_group_id(1)\n"
"#define NUM_BLOCKS_X get_num_groups(0)\n"
"#define __syncthreads() barrier(CLK_LOCAL_MEM_FENCE)\n"
"#define ucl_inline inline\n"
"#define fetch4(ans,i,x) ans=x[i]\n"
"#define fetch(ans,i,q) ans=q[i]\n"
"#ifndef _SINGLE_SINGLE\n"
"#ifndef cl_khr_fp64\n"
"#ifndef cl_amd_fp64\n"
"#pragma OPENCL EXTENSION cl_khr_fp64 : enable\n"
"#endif\n"
"#endif\n"
"#if defined(cl_khr_fp64)\n"
"#pragma OPENCL EXTENSION cl_khr_fp64 : enable\n"
"#elif defined(cl_amd_fp64)\n"
"#pragma OPENCL EXTENSION cl_amd_fp64 : enable\n"
"#endif\n"
"#endif\n"
"#define fast_mul(X,Y) (X)*(Y)\n"
"#define ucl_atan atan\n"
"#define ucl_cbrt cbrt\n"
"#define ucl_ceil ceil\n"
"#define ucl_abs fabs\n"
"#if defined(FAST_MATH) && !defined(_DOUBLE_DOUBLE)\n"
"#define ucl_exp native_exp\n"
"#define ucl_powr native_powr\n"
"#define ucl_rsqrt native_rsqrt\n"
"#define ucl_sqrt native_sqrt\n"
"#define ucl_recip native_recip\n"
"#else\n"
"#define ucl_exp exp\n"
"#define ucl_powr powr\n"
"#define ucl_rsqrt rsqrt\n"
"#define ucl_sqrt sqrt\n"
"#define ucl_recip(x) ((numtyp)1.0/(x))\n"
"#endif\n"
"#if (SHUFFLE_AVAIL == 1)\n"
"  #ifdef cl_intel_subgroups\n"
"    #pragma OPENCL EXTENSION cl_intel_subgroups : enable\n"
"    #define shfl_down(var, delta, width) \\\n"
"      intel_sub_group_shuffle_down(var, var, delta)\n"
"    #define shfl_xor(var, lanemask, width) \\\n"
"      intel_sub_group_shuffle_xor(var, lanemask)\n"
"    #define simd_broadcast_i(var, src, width) sub_group_broadcast(var, src)\n"
"    #define simd_broadcast_f(var, src, width) sub_group_broadcast(var, src)\n"
"    #define simd_broadcast_d(var, src, width) sub_group_broadcast(var, src)\n"
"  #else\n"
"    #ifdef _SINGLE_SINGLE\n"
"      inline float shfl_down(float var, unsigned int delta, int width) {\n"
"        float ret;\n"
"        int c;\n"
"        c = ((SIMD_SIZE-width) << 8) | 0x1f;\n"
"        asm volatile (\"shfl.sync.down.b32 %0, %1, %2, %3, %4;\" : \"=f\"(ret) : \"f\"(var), \"r\"(delta), \"r\"(c), \"r\"(0xffffffff));\n"
"        return ret;\n"
"      }\n"
"      inline float shfl_xor(float var, unsigned int lanemask, int width) {\n"
"        float ret;\n"
"        int c;\n"
"        c = ((SIMD_SIZE-width) << 8) | 0x1f;\n"
"        asm volatile (\"shfl.sync.bfly.b32 %0, %1, %2, %3, %4;\" : \"=f\"(ret) : \"f\"(var), \"r\"(lanemask), \"r\"(c), \"r\"(0xffffffff));\n"
"        return ret;\n"
"      }\n"
"    #else\n"
"      inline double shfl_down(double var, unsigned int delta, int width) {\n"
"        int c = ((SIMD_SIZE-width) << 8) | 0x1f;\n"
"        int x,y,x2,y2;\n"
"        double ans;\n"
"        asm volatile (\"mov.b64 {%0, %1}, %2;\" : \"=r\"(y), \"=r\"(x) : \"d\"(var));\n"
"        asm volatile (\"shfl.sync.down.b32 %0, %1, %2, %3, %4;\" : \"=r\"(x2) : \"r\"(x), \"r\"(delta), \"r\"(c), \"r\"(0xffffffff));\n"
"        asm volatile (\"shfl.sync.down.b32 %0, %1, %2, %3, %4;\" : \"=r\"(y2) : \"r\"(y), \"r\"(delta), \"r\"(c), \"r\"(0xffffffff));\n"
"        asm volatile (\"mov.b64 %0, {%1, %2};\" : \"=d\"(ans) : \"r\"(y2), \"r\"(x2));\n"
"        return ans;\n"
"      }\n"
"      inline double shfl_xor(double var, unsigned int lanemask, int width) {\n"
"        int c = ((SIMD_SIZE-width) << 8) | 0x1f;\n"
"        int x,y,x2,y2;\n"
"        double ans;\n"
"        asm volatile (\"mov.b64 {%0, %1}, %2;\" : \"=r\"(y), \"=r\"(x) : \"d\"(var));\n"
"        asm volatile (\"shfl.sync.bfly.b32 %0, %1, %2, %3, %4;\" : \"=r\"(x2) : \"r\"(x), \"r\"(lanemask), \"r\"(c), \"r\"(0xffffffff));\n"
"        asm volatile (\"shfl.sync.bfly.b32 %0, %1, %2, %3, %4;\" : \"=r\"(y2) : \"r\"(y), \"r\"(lanemask), \"r\"(c), \"r\"(0xffffffff));\n"
"        asm volatile (\"mov.b64 %0, {%1, %2};\" : \"=d\"(ans) : \"r\"(y2), \"r\"(x2));\n"
"        return ans;\n"
"      }\n"
"    #endif\n"
"    inline int simd_broadcast_i(int var, unsigned int src, int width) {\n"
"      int ret;\n"
"      int c;\n"
"      c = ((SIMD_SIZE-width) << 8) | 0x1f;\n"
"      asm volatile (\"shfl.sync.idx.b32 %0, %1, %2, %3, %4;\" : \"=f\"(ret) : \"f\"(var), \"r\"(src), \"r\"(c), \"r\"(0xffffffff));\n"
"      return ret;\n"
"    }\n"
"    inline float simd_broadcast_f(float var, unsigned int src, int width) {\n"
"      float ret;\n"
"      int c;\n"
"      c = ((SIMD_SIZE-width) << 8) | 0x1f;\n"
"      asm volatile (\"shfl.sync.idx.b32 %0, %1, %2, %3, %4;\" : \"=f\"(ret) : \"f\"(var), \"r\"(src), \"r\"(c), \"r\"(0xffffffff));\n"
"      return ret;\n"
"    }\n"
"    #ifdef _DOUBLE_DOUBLE\n"
"      inline double simd_broadcast_d(double var, unsigned int src, int width) {\n"
"        int c = ((SIMD_SIZE-width) << 8) | 0x1f;\n"
"        int x,y,x2,y2;\n"
"        double ans;\n"
"        asm volatile (\"mov.b64 {%0, %1}, %2;\" : \"=r\"(y), \"=r\"(x) : \"d\"(var));\n"
"        asm volatile (\"shfl.sync.idx.b32 %0, %1, %2, %3, %4;\" : \"=r\"(x2) : \"r\"(x), \"r\"(src), \"r\"(c), \"r\"(0xffffffff));\n"
"        asm volatile (\"shfl.sync.idx.b32 %0, %1, %2, %3, %4;\" : \"=r\"(y2) : \"r\"(y), \"r\"(src), \"r\"(c), \"r\"(0xffffffff));\n"
"        asm volatile (\"mov.b64 %0, {%1, %2};\" : \"=d\"(ans) : \"r\"(y2), \"r\"(x2));\n"
"        return ans;\n"
"      }\n"
"    #endif\n"
"  #endif\n"
"#endif\n"
"#ifdef USE_OPENCL_SUBGROUPS\n"
"  #ifndef cl_intel_subgroups\n"
"    #pragma OPENCL EXTENSION cl_khr_subgroups : enable\n"
"  #endif\n"
"  #define simdsync() sub_group_barrier(CLK_LOCAL_MEM_FENCE)\n"
"  #define simd_size() get_max_sub_group_size()\n"
"#else\n"
"  #define simdsync()\n"
"  #define simd_size() SIMD_SIZE\n"
"#endif\n"
"#endif\n"
"#ifdef _DOUBLE_DOUBLE\n"
"#define numtyp double\n"
"#define numtyp2 double2\n"
"#define numtyp4 double4\n"
"#define acctyp double\n"
"#define acctyp2 double2\n"
"#define acctyp4 double4\n"
"#endif\n"
"#ifdef _SINGLE_DOUBLE\n"
"#define numtyp float\n"
"#define numtyp2 float2\n"
"#define numtyp4 float4\n"
"#define acctyp double\n"
"#define acctyp2 double2\n"
"#define acctyp4 double4\n"
"#endif\n"
"#ifndef numtyp\n"
"#define numtyp float\n"
"#define numtyp2 float2\n"
"#define numtyp4 float4\n"
"#define acctyp float\n"
"#define acctyp2 float2\n"
"#define acctyp4 float4\n"
"#endif\n"
"#define EWALD_F (numtyp)1.12837917\n"
"#define EWALD_P (numtyp)0.3275911\n"
"#define A1 (numtyp)0.254829592\n"
"#define A2 (numtyp)-0.284496736\n"
"#define A3 (numtyp)1.421413741\n"
"#define A4 (numtyp)-1.453152027\n"
"#define A5 (numtyp)1.061405429\n"
"#define SBBITS 30\n"
"#define NEIGHMASK 0x3FFFFFFF\n"
"ucl_inline int sbmask(int j) { return j >> SBBITS & 3; };\n"
"#if !defined(LAMMPS_SMALLSMALL) && !defined(LAMMPS_BIGBIG) && \\\n"
"    !defined(LAMMPS_SMALLBIG)\n"
"#define LAMMPS_SMALLBIG\n"
"#endif\n"

"#if defined(NV_KERNEL) || defined(USE_HIP)\n"
"#include \"lal_preprocessor.h\"\n"
"#endif\n"
"#define atom_info(t_per_atom, ii, tid, offset)                               \\\n"
"  tid=THREAD_ID_X;                                                           \\\n"
"  offset=tid & (t_per_atom-1);                                               \\\n"
"  ii=fast_mul((int)BLOCK_ID_X,(int)(BLOCK_SIZE_X)/t_per_atom)+tid/t_per_atom;\n"
"#define nbor_info(dev_nbor, dev_packed, nbor_pitch, t_per_atom, ii, offset,  \\\n"
"                  i, numj, n_stride, nbor_end, nbor_begin)                   \\\n"
"  i=dev_nbor[ii];                                                            \\\n"
"  nbor_begin=ii+nbor_pitch;                                                  \\\n"
"  numj=dev_nbor[nbor_begin];                                                 \\\n"
"  if (dev_nbor==dev_packed) {                                                \\\n"
"    nbor_begin+=nbor_pitch+fast_mul(ii,t_per_atom-1);                        \\\n"
"    n_stride=fast_mul(t_per_atom,nbor_pitch);                                \\\n"
"    nbor_end=nbor_begin+fast_mul(numj/t_per_atom,n_stride)+(numj & (t_per_atom-1)); \\\n"
"    nbor_begin+=offset;                                                      \\\n"
"  } else {                                                                   \\\n"
"    nbor_begin+=nbor_pitch;                                                  \\\n"
"    nbor_begin=dev_nbor[nbor_begin];                                         \\\n"
"    nbor_end=nbor_begin+numj;                                                \\\n"
"    n_stride=t_per_atom;                                                     \\\n"
"    nbor_begin+=offset;                                                      \\\n"
"  }\n"
"#define nbor_info_p(nbor_mem, nbor_stride, t_per_atom, ii, offset,           \\\n"
"                    i, numj, stride, nbor_end, nbor_begin)                   \\\n"
"    i=nbor_mem[ii];                                                          \\\n"
"    nbor_begin=ii+nbor_stride;                                               \\\n"
"    numj=nbor_mem[nbor_begin];                                               \\\n"
"    nbor_begin+=nbor_stride+ii*(t_per_atom-1);                               \\\n"
"    stride=fast_mul(t_per_atom,nbor_stride);                                 \\\n"
"    nbor_end=nbor_begin+fast_mul(numj/t_per_atom,stride)+(numj &             \\\n"
"                                                          (t_per_atom-1));   \\\n"
"    nbor_begin+=offset;\n"
"#if (SHUFFLE_AVAIL == 0)\n"
"#define simd_reduce_add1(width, local, offset, tid, one)                    \\\n"
"  local[0][tid]=one;                                                        \\\n"
"  for (unsigned int s=width/2; s>0; s>>=1) {                                \\\n"
"    simdsync();                                                             \\\n"
"    if (offset < s) local[0][tid] += local[0][tid+s];                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) one=local[0][tid];\n"
"#define simd_reduce_add2(width, local, offset, tid, one, two)               \\\n"
"  local[0][tid]=one;                                                        \\\n"
"  local[1][tid]=two;                                                        \\\n"
"  for (unsigned int s=width/2; s>0; s>>=1) {                                \\\n"
"    simdsync();                                                             \\\n"
"    if (offset < s) {                                                       \\\n"
"      local[0][tid] += local[0][tid+s];                                     \\\n"
"      local[1][tid] += local[1][tid+s];                                     \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    one=local[0][tid];                                                      \\\n"
"    two=local[1][tid];                                                      \\\n"
"  }\n"
"#define simd_reduce_add3(width, local, offset, tid, one, two, three)        \\\n"
"  local[0][tid]=one;                                                        \\\n"
"  local[1][tid]=two;                                                        \\\n"
"  local[2][tid]=three;                                                      \\\n"
"  for (unsigned int s=width/2; s>0; s>>=1) {                                \\\n"
"    simdsync();                                                             \\\n"
"    if (offset < s) {                                                       \\\n"
"      local[0][tid] += local[0][tid+s];                                     \\\n"
"      local[1][tid] += local[1][tid+s];                                     \\\n"
"      local[2][tid] += local[2][tid+s];                                     \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    one=local[0][tid];                                                      \\\n"
"    two=local[1][tid];                                                      \\\n"
"    three=local[2][tid];                                                    \\\n"
"  }\n"
"#define simd_reduce_add6(width, local, offset, tid, one, two, three,        \\\n"
"                         four, five, six)                                   \\\n"
"  local[0][tid]=one;                                                        \\\n"
"  local[1][tid]=two;                                                        \\\n"
"  local[2][tid]=three;                                                      \\\n"
"  local[3][tid]=four;                                                       \\\n"
"  local[4][tid]=five;                                                       \\\n"
"  local[5][tid]=six;                                                        \\\n"
"  for (unsigned int s=width/2; s>0; s>>=1) {                                \\\n"
"    simdsync();                                                             \\\n"
"    if (offset < s) {                                                       \\\n"
"      local[0][tid] += local[0][tid+s];                                     \\\n"
"      local[1][tid] += local[1][tid+s];                                     \\\n"
"      local[2][tid] += local[2][tid+s];                                     \\\n"
"      local[3][tid] += local[3][tid+s];                                     \\\n"
"      local[4][tid] += local[4][tid+s];                                     \\\n"
"      local[5][tid] += local[5][tid+s];                                     \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    one=local[0][tid];                                                      \\\n"
"    two=local[1][tid];                                                      \\\n"
"    three=local[2][tid];                                                    \\\n"
"    four=local[3][tid];                                                     \\\n"
"    five=local[4][tid];                                                     \\\n"
"    six=local[5][tid];                                                      \\\n"
"  }\n"
"#define simd_reduce_arr(trip, width, local, offset, tid, arr)               \\\n"
"  for (int r=0; r<trip; r++)                                                \\\n"
"    local[r][tid]=arr[r];                                                   \\\n"
"  for (unsigned int s=width/2; s>0; s>>=1) {                                \\\n"
"    simdsync();                                                             \\\n"
"    if (offset < s) {                                                       \\\n"
"      for (int r=0; r<trip; r++)                                            \\\n"
"        local[r][tid] += local[r][tid+s];                                   \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    for (int r=0; r<trip; r++)                                              \\\n"
"      arr[r]=local[r][tid];                                                 \\\n"
"  }\n"
"#define block_reduce_add1(width, local, tid, one)                           \\\n"
"  local[0][tid]=one;                                                        \\\n"
"  for (unsigned int s=BLOCK_SIZE_X/2; s>width/2; s>>=1) {                   \\\n"
"    __syncthreads();                                                        \\\n"
"    if (tid < s) local[0][tid] += local[0][tid+s];                          \\\n"
"  }                                                                         \\\n"
"  if (tid<width) {                                                          \\\n"
"    for (unsigned int s=width/2; s>0; s>>=1) {                              \\\n"
"      simdsync();                                                           \\\n"
"      if (tid < s) local[0][tid] += local[0][tid+s];                        \\\n"
"    }                                                                       \\\n"
"    if (tid==0) one=local[0][tid];                                          \\\n"
"  }\n"
"#define block_reduce_add2(width, local, tid, one, two)                      \\\n"
"  local[0][tid]=one;                                                        \\\n"
"  local[1][tid]=two;                                                        \\\n"
"  for (unsigned int s=BLOCK_SIZE_X/2; s>width/2; s>>=1) {                   \\\n"
"    __syncthreads();                                                        \\\n"
"    if (tid < s) {                                                          \\\n"
"      local[0][tid] += local[0][tid+s];                                     \\\n"
"      local[1][tid] += local[1][tid+s];                                     \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (tid<width) {                                                          \\\n"
"    for (unsigned int s=width/2; s>0; s>>=1) {                              \\\n"
"      simdsync();                                                           \\\n"
"      if (tid < s) {                                                        \\\n"
"        local[0][tid] += local[0][tid+s];                                   \\\n"
"        local[1][tid] += local[1][tid+s];                                   \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    if (tid==0) {                                                           \\\n"
"      one=local[0][tid];                                                    \\\n"
"      two=local[1][tid];                                                    \\\n"
"    }                                                                       \\\n"
"  }\n"
"#define block_reduce_arr(trip, width, local, tid, arr)                      \\\n"
"  for (int r=0; r<trip; r++)                                                \\\n"
"    local[r][tid]=arr[r];                                                   \\\n"
"  for (unsigned int s=BLOCK_SIZE_X/2; s>width/2; s>>=1) {                   \\\n"
"    __syncthreads();                                                        \\\n"
"    if (tid < s) {                                                          \\\n"
"      for (int r=0; r<trip; r++)                                            \\\n"
"        local[r][tid] += local[r][tid+s];                                   \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (tid<width) {                                                          \\\n"
"    for (unsigned int s=width/2; s>0; s>>=1) {                              \\\n"
"      simdsync();                                                           \\\n"
"      if (tid < s) {                                                        \\\n"
"        for (int r=0; r<trip; r++)                                          \\\n"
"          local[r][tid] += local[r][tid+s];                                 \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    if (tid==0) {                                                           \\\n"
"      for (int r=0; r<trip; r++)                                            \\\n"
"        arr[r]=local[r][tid];                                               \\\n"
"    }                                                                       \\\n"
"  }\n"
"#define local_allocate_store_pair()                                         \\\n"
"    __local acctyp red_acc[6][BLOCK_PAIR];\n"
"#define local_allocate_store_charge()                                       \\\n"
"    __local acctyp red_acc[6][BLOCK_PAIR];\n"
"#define local_allocate_store_bio()                                          \\\n"
"    __local acctyp red_acc[6][BLOCK_BIO_PAIR];\n"
"#define local_allocate_store_ellipse()                                      \\\n"
"    __local acctyp red_acc[6][BLOCK_ELLIPSE];\n"
"#define local_allocate_store_three()                                        \\\n"
"    __local acctyp red_acc[6][BLOCK_ELLIPSE];\n"
"#define store_answers(f, energy, virial, ii, inum, tid,                     \\\n"
"                        t_per_atom, offset, eflag, vflag, ans, engv)        \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    simd_reduce_add3(t_per_atom, red_acc, offset, tid, f.x, f.y, f.z);      \\\n"
"    if (EVFLAG && (vflag==2 || eflag==2)) {                                 \\\n"
"      if (eflag) {                                                          \\\n"
"        simdsync();                                                         \\\n"
"        simd_reduce_add1(t_per_atom, red_acc, offset, tid, energy);         \\\n"
"      }                                                                     \\\n"
"      if (vflag) {                                                          \\\n"
"        simdsync();                                                         \\\n"
"        simd_reduce_arr(6, t_per_atom, red_acc, offset, tid, virial);       \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0 && ii<inum) ans[ii]=f;                                      \\\n"
"  if (EVFLAG && (eflag || vflag)) {                                         \\\n"
"    int ei=BLOCK_ID_X;                                                      \\\n"
"    if (eflag!=2 && vflag!=2) {                                             \\\n"
"      const int ev_stride=NUM_BLOCKS_X;                                     \\\n"
"      if (eflag) {                                                          \\\n"
"        simdsync();                                                         \\\n"
"        block_reduce_add1(simd_size(), red_acc, tid, energy);               \\\n"
"        if (vflag) __syncthreads();                                         \\\n"
"        if (tid==0) {                                                       \\\n"
"          engv[ei]=energy*(acctyp)0.5;                                      \\\n"
"          ei+=ev_stride;                                                    \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"      if (vflag) {                                                          \\\n"
"        simdsync();                                                         \\\n"
"        block_reduce_arr(6, simd_size(), red_acc, tid, virial);             \\\n"
"        if (tid==0) {                                                       \\\n"
"          for (int r=0; r<6; r++) {                                         \\\n"
"            engv[ei]=virial[r]*(acctyp)0.5;                                 \\\n"
"            ei+=ev_stride;                                                  \\\n"
"          }                                                                 \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"    } else if (offset==0 && ii<inum) {                                      \\\n"
"      int ei=ii;                                                            \\\n"
"      if (EVFLAG && eflag) {                                                \\\n"
"        engv[ei]=energy*(acctyp)0.5;                                        \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"      if (EVFLAG && vflag) {                                                \\\n"
"        for (int i=0; i<6; i++) {                                           \\\n"
"          engv[ei]=virial[i]*(acctyp)0.5;                                   \\\n"
"          ei+=inum;                                                         \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"  }\n"
"#define store_answers_q(f, energy, e_coul, virial, ii, inum, tid,           \\\n"
"                        t_per_atom, offset, eflag, vflag, ans, engv)        \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    simd_reduce_add3(t_per_atom, red_acc, offset, tid, f.x, f.y, f.z);      \\\n"
"    if (EVFLAG && (vflag==2 || eflag==2)) {                                 \\\n"
"      if (eflag) {                                                          \\\n"
"        simdsync();                                                         \\\n"
"        simd_reduce_add2(t_per_atom, red_acc, offset, tid, energy, e_coul); \\\n"
"      }                                                                     \\\n"
"      if (vflag) {                                                          \\\n"
"        simdsync();                                                         \\\n"
"        simd_reduce_arr(6, t_per_atom, red_acc, offset, tid, virial);       \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0 && ii<inum) ans[ii]=f;                                      \\\n"
"  if (EVFLAG && (eflag || vflag)) {                                         \\\n"
"    int ei=BLOCK_ID_X;                                                      \\\n"
"    const int ev_stride=NUM_BLOCKS_X;                                       \\\n"
"    if (eflag!=2 && vflag!=2) {                                             \\\n"
"      if (eflag) {                                                          \\\n"
"        simdsync();                                                         \\\n"
"        block_reduce_add2(simd_size(), red_acc, tid, energy, e_coul);       \\\n"
"        if (vflag) __syncthreads();                                         \\\n"
"        if (tid==0) {                                                       \\\n"
"          engv[ei]=energy*(acctyp)0.5;                                      \\\n"
"          ei+=ev_stride;                                                    \\\n"
"          engv[ei]=e_coul*(acctyp)0.5;                                      \\\n"
"          ei+=ev_stride;                                                    \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"      if (vflag) {                                                          \\\n"
"        simdsync();                                                         \\\n"
"        block_reduce_arr(6, simd_size(), red_acc, tid, virial);             \\\n"
"        if (tid==0) {                                                       \\\n"
"          for (int r=0; r<6; r++) {                                         \\\n"
"            engv[ei]=virial[r]*(acctyp)0.5;                                 \\\n"
"            ei+=ev_stride;                                                  \\\n"
"          }                                                                 \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"    } else if (offset==0 && ii<inum) {                                      \\\n"
"      int ei=ii;                                                            \\\n"
"      if (EVFLAG && eflag) {                                                \\\n"
"        engv[ei]=energy*(acctyp)0.5;                                        \\\n"
"        ei+=inum;                                                           \\\n"
"        engv[ei]=e_coul*(acctyp)0.5;                                        \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"      if (EVFLAG && vflag) {                                                \\\n"
"        for (int i=0; i<6; i++) {                                           \\\n"
"          engv[ei]=virial[i]*(acctyp)0.5;                                   \\\n"
"          ei+=inum;                                                         \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"  }\n"
"#else\n"
"#define simd_reduce_add1(width, one)                                        \\\n"
"  for (unsigned int s=width/2; s>0; s>>=1) one += shfl_down(one, s, width);\n"
"#define simd_reduce_add2(width, one, two)                                   \\\n"
"  for (unsigned int s=width/2; s>0; s>>=1) {                                \\\n"
"    one += shfl_down(one, s, width);                                        \\\n"
"    two += shfl_down(two, s, width);                                        \\\n"
"  }\n"
"#define simd_reduce_add3(width, one, two, three)                            \\\n"
"  for (unsigned int s=width/2; s>0; s>>=1) {                                \\\n"
"    one += shfl_down(one, s, width);                                        \\\n"
"    two += shfl_down(two, s, width);                                        \\\n"
"    three += shfl_down(three, s, width);                                    \\\n"
"  }\n"
"#define simd_reduce_add6(width, one, two, three, four, five, six)           \\\n"
"  for (unsigned int s=width/2; s>0; s>>=1) {                                \\\n"
"    one += shfl_down(one, s, width);                                        \\\n"
"    two += shfl_down(two, s, width);                                        \\\n"
"    three += shfl_down(three, s, width);                                    \\\n"
"    four += shfl_down(four, s, width);                                      \\\n"
"    five += shfl_down(five, s, width);                                      \\\n"
"    six += shfl_down(six, s, width);                                        \\\n"
"  }\n"
"#define simd_reduce_arr(trip, width, arr)                                   \\\n"
"  for (unsigned int s=width/2; s>0; s>>=1) {                                \\\n"
"    for (int r=0; r<trip; r++)                                              \\\n"
"      arr[r] += shfl_down(arr[r], s, width);                                \\\n"
"  }\n"
"#if (EVFLAG == 1)\n"
"#define local_allocate_store_pair()                                         \\\n"
"    __local acctyp red_acc[7][BLOCK_PAIR / SIMD_SIZE];\n"
"#define local_allocate_store_charge()                                       \\\n"
"    __local acctyp red_acc[8][BLOCK_PAIR / SIMD_SIZE];\n"
"#define local_allocate_store_bio()                                          \\\n"
"    __local acctyp red_acc[8][BLOCK_BIO_PAIR / SIMD_SIZE];\n"
"#define local_allocate_store_ellipse()\n"
"#define local_allocate_store_three()                                        \\\n"
"    __local acctyp red_acc[7][BLOCK_ELLIPSE / SIMD_SIZE];\n"
"#define store_answers(f, energy, virial, ii, inum, tid,                     \\\n"
"                      t_per_atom, offset, eflag, vflag, ans, engv)          \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    simd_reduce_add3(t_per_atom, f.x, f.y, f.z);                            \\\n"
"    if (vflag==2 || eflag==2) {                                             \\\n"
"      if (eflag)                                                            \\\n"
"        simd_reduce_add1(t_per_atom,energy);                                \\\n"
"      if (vflag)                                                            \\\n"
"        simd_reduce_arr(6, t_per_atom,virial);                              \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0 && ii<inum) ans[ii]=f;                                      \\\n"
"  if (eflag || vflag) {                                                     \\\n"
"    if (eflag!=2 && vflag!=2) {                                             \\\n"
"      const int vwidth = simd_size();                                       \\\n"
"      const int voffset = tid & (simd_size() - 1);                          \\\n"
"      const int bnum = tid/simd_size();                                     \\\n"
"      int active_subgs = BLOCK_SIZE_X/simd_size();                          \\\n"
"      for ( ; active_subgs > 1; active_subgs /= vwidth) {                   \\\n"
"        if (active_subgs < BLOCK_SIZE_X/simd_size()) __syncthreads();       \\\n"
"        if (bnum < active_subgs) {                                          \\\n"
"          if (eflag) {                                                      \\\n"
"            simd_reduce_add1(vwidth, energy);                               \\\n"
"            if (voffset==0) red_acc[6][bnum] = energy;                      \\\n"
"          }                                                                 \\\n"
"          if (vflag) {                                                      \\\n"
"            simd_reduce_arr(6, vwidth, virial);                             \\\n"
"            if (voffset==0)                                                 \\\n"
"              for (int r=0; r<6; r++) red_acc[r][bnum]=virial[r];           \\\n"
"          }                                                                 \\\n"
"        }                                                                   \\\n"
"                                                                            \\\n"
"        __syncthreads();                                                    \\\n"
"        if (tid < active_subgs) {                                           \\\n"
"            if (eflag) energy = red_acc[6][tid];                            \\\n"
"          if (vflag)                                                        \\\n"
"            for (int r = 0; r < 6; r++) virial[r] = red_acc[r][tid];        \\\n"
"        } else {                                                            \\\n"
"          if (eflag) energy = (acctyp)0;                                    \\\n"
"          if (vflag) for (int r = 0; r < 6; r++) virial[r] = (acctyp)0;     \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"                                                                            \\\n"
"      if (bnum == 0) {                                                      \\\n"
"        int ei=BLOCK_ID_X;                                                  \\\n"
"        const int ev_stride=NUM_BLOCKS_X;                                   \\\n"
"        if (eflag) {                                                        \\\n"
"          simd_reduce_add1(vwidth, energy);                                 \\\n"
"          if (tid==0) {                                                     \\\n"
"            engv[ei]=energy*(acctyp)0.5;                                    \\\n"
"            ei+=ev_stride;                                                  \\\n"
"          }                                                                 \\\n"
"        }                                                                   \\\n"
"        if (vflag) {                                                        \\\n"
"          simd_reduce_arr(6, vwidth, virial);                               \\\n"
"          if (tid==0) {                                                     \\\n"
"            for (int r=0; r<6; r++) {                                       \\\n"
"              engv[ei]=virial[r]*(acctyp)0.5;                               \\\n"
"              ei+=ev_stride;                                                \\\n"
"            }                                                               \\\n"
"          }                                                                 \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"    } else if (offset==0 && ii<inum) {                                      \\\n"
"      int ei=ii;                                                            \\\n"
"      if (eflag) {                                                          \\\n"
"        engv[ei]=energy*(acctyp)0.5;                                        \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"      if (vflag) {                                                          \\\n"
"        for (int i=0; i<6; i++) {                                           \\\n"
"          engv[ei]=virial[i]*(acctyp)0.5;                                   \\\n"
"          ei+=inum;                                                         \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"  }\n"
"#define store_answers_q(f, energy, e_coul, virial, ii, inum, tid,           \\\n"
"                        t_per_atom, offset, eflag, vflag, ans, engv)        \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    simd_reduce_add3(t_per_atom, f.x, f.y, f.z);                            \\\n"
"    if (vflag==2 || eflag==2) {                                             \\\n"
"      if (eflag)                                                            \\\n"
"        simd_reduce_add2(t_per_atom,energy,e_coul);                         \\\n"
"      if (vflag)                                                            \\\n"
"        simd_reduce_arr(6, t_per_atom,virial);                              \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0 && ii<inum) ans[ii]=f;                                      \\\n"
"  if (eflag || vflag) {                                                     \\\n"
"    if (eflag!=2 && vflag!=2) {                                             \\\n"
"      const int vwidth = simd_size();                                       \\\n"
"      const int voffset = tid & (simd_size() - 1);                          \\\n"
"      const int bnum = tid/simd_size();                                     \\\n"
"      int active_subgs = BLOCK_SIZE_X/simd_size();                          \\\n"
"      for ( ; active_subgs > 1; active_subgs /= vwidth) {                   \\\n"
"        if (active_subgs < BLOCK_SIZE_X/simd_size()) __syncthreads();       \\\n"
"        if (bnum < active_subgs) {                                          \\\n"
"          if (eflag) {                                                      \\\n"
"            simd_reduce_add2(vwidth, energy, e_coul);                       \\\n"
"            if (voffset==0) {                                               \\\n"
"              red_acc[6][bnum] = energy;                                    \\\n"
"              red_acc[7][bnum] = e_coul;                                    \\\n"
"            }                                                               \\\n"
"          }                                                                 \\\n"
"          if (vflag) {                                                      \\\n"
"            simd_reduce_arr(6, vwidth, virial);                             \\\n"
"            if (voffset==0)                                                 \\\n"
"              for (int r=0; r<6; r++) red_acc[r][bnum]=virial[r];           \\\n"
"          }                                                                 \\\n"
"        }                                                                   \\\n"
"                                                                            \\\n"
"        __syncthreads();                                                    \\\n"
"        if (tid < active_subgs) {                                           \\\n"
"          if (eflag) {                                                      \\\n"
"            energy = red_acc[6][tid];                                       \\\n"
"            e_coul = red_acc[7][tid];                                       \\\n"
"          }                                                                 \\\n"
"          if (vflag)                                                        \\\n"
"            for (int r = 0; r < 6; r++) virial[r] = red_acc[r][tid];        \\\n"
"        } else {                                                            \\\n"
"          if (eflag) energy = e_coul = (acctyp)0;                           \\\n"
"          if (vflag) for (int r = 0; r < 6; r++) virial[r] = (acctyp)0;     \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"                                                                            \\\n"
"      if (bnum == 0) {                                                      \\\n"
"        int ei=BLOCK_ID_X;                                                  \\\n"
"        const int ev_stride=NUM_BLOCKS_X;                                   \\\n"
"        if (eflag) {                                                        \\\n"
"          simd_reduce_add2(vwidth, energy, e_coul);                         \\\n"
"          if (tid==0) {                                                     \\\n"
"            engv[ei]=energy*(acctyp)0.5;                                    \\\n"
"            ei+=ev_stride;                                                  \\\n"
"            engv[ei]=e_coul*(acctyp)0.5;                                    \\\n"
"            ei+=ev_stride;                                                  \\\n"
"          }                                                                 \\\n"
"        }                                                                   \\\n"
"        if (vflag) {                                                        \\\n"
"          simd_reduce_arr(6, vwidth, virial);                               \\\n"
"          if (tid==0) {                                                     \\\n"
"            for (int r=0; r<6; r++) {                                       \\\n"
"              engv[ei]=virial[r]*(acctyp)0.5;                               \\\n"
"              ei+=ev_stride;                                                \\\n"
"            }                                                               \\\n"
"          }                                                                 \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"    } else if (offset==0 && ii<inum) {                                      \\\n"
"      int ei=ii;                                                            \\\n"
"      if (eflag) {                                                          \\\n"
"        engv[ei]=energy*(acctyp)0.5;                                        \\\n"
"        ei+=inum;                                                           \\\n"
"        engv[ei]=e_coul*(acctyp)0.5;                                        \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"      if (vflag) {                                                          \\\n"
"        for (int i=0; i<6; i++) {                                           \\\n"
"          engv[ei]=virial[i]*(acctyp)0.5;                                   \\\n"
"          ei+=inum;                                                         \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"  }\n"
"#else\n"
"#define local_allocate_store_pair()\n"
"#define local_allocate_store_charge()\n"
"#define local_allocate_store_bio()\n"
"#define local_allocate_store_ellipse()\n"
"#define local_allocate_store_three()\n"
"#define store_answers(f, energy, virial, ii, inum, tid,                     \\\n"
"                      t_per_atom, offset, eflag, vflag, ans, engv)          \\\n"
"  if (t_per_atom>1)                                                         \\\n"
"    simd_reduce_add3(t_per_atom, f.x, f.y, f.z);                            \\\n"
"  if (offset==0 && ii<inum) ans[ii]=f;\n"
"#define store_answers_q(f, energy, e_coul, virial, ii, inum, tid,           \\\n"
"                        t_per_atom, offset, eflag, vflag, ans, engv)        \\\n"
"  if (t_per_atom>1)                                                         \\\n"
"    simd_reduce_add3(t_per_atom, f.x, f.y, f.z);                            \\\n"
"  if (offset==0 && ii<inum) ans[ii]=f;\n"
"#endif\n"
"#endif\n"

"#if defined(NV_KERNEL) || defined(USE_HIP)\n"
"#include \"lal_aux_fun1.h\"\n"
"#ifndef _DOUBLE_DOUBLE\n"
"_texture( pos_tex,float4);\n"
"#else\n"
"_texture_2d( pos_tex,int4);\n"
"#endif\n"
"#else\n"
"#define pos_tex x_\n"
"#endif\n"
"__kernel void k_lj_sdk(const __global numtyp4 *restrict x_,\n"
"                       const __global numtyp4 *restrict lj1,\n"
"                       const __global numtyp4 *restrict lj3,\n"
"                       const int lj_types,\n"
"                       const __global numtyp *restrict sp_lj_in,\n"
"                       const __global int *dev_nbor,\n"
"                       const __global int *dev_packed,\n"
"                       __global acctyp4 *restrict ans,\n"
"                       __global acctyp *restrict engv,\n"
"                       const int eflag, const int vflag, const int inum,\n"
"                       const int nbor_pitch, const int t_per_atom) {\n"
"  int tid, ii, offset;\n"
"  atom_info(t_per_atom,ii,tid,offset);\n"
"  __local numtyp sp_lj[4];\n"
"  int n_stride;\n"
"  local_allocate_store_pair();\n"
"  sp_lj[0]=sp_lj_in[0];\n"
"  sp_lj[1]=sp_lj_in[1];\n"
"  sp_lj[2]=sp_lj_in[2];\n"
"  sp_lj[3]=sp_lj_in[3];\n"
"  acctyp4 f;\n"
"  f.x=(acctyp)0; f.y=(acctyp)0; f.z=(acctyp)0;\n"
"  acctyp energy, virial[6];\n"
"  if (EVFLAG) {\n"
"    energy=(acctyp)0;\n"
"    for (int i=0; i<6; i++) virial[i]=(acctyp)0;\n"
"  }\n"
"  if (ii<inum) {\n"
"    int nbor, nbor_end;\n"
"    int i, numj;\n"
"    nbor_info(dev_nbor,dev_packed,nbor_pitch,t_per_atom,ii,offset,i,numj,\n"
"              n_stride,nbor_end,nbor);\n"
"    numtyp4 ix; fetch4(ix,i,pos_tex); \n"
"    int itype=ix.w;\n"
"    numtyp factor_lj;\n"
"    for ( ; nbor<nbor_end; nbor+=n_stride) {\n"
"      int j=dev_packed[nbor];\n"
"      factor_lj = sp_lj[sbmask(j)];\n"
"      j &= NEIGHMASK;\n"
"      numtyp4 jx; fetch4(jx,j,pos_tex); \n"
"      int jtype=jx.w;\n"
"      \n"
"      numtyp delx = ix.x-jx.x;\n"
"      numtyp dely = ix.y-jx.y;\n"
"      numtyp delz = ix.z-jx.z;\n"
"      numtyp r2inv = delx*delx+dely*dely+delz*delz;\n"
"      int mtype=itype*lj_types+jtype;\n"
"      if (r2inv<lj1[mtype].x) {\n"
"        r2inv=ucl_recip(r2inv);\n"
"        numtyp inv1,inv2;\n"
"        if (lj1[mtype].y == 2) {\n"
"          inv1=r2inv*r2inv;\n"
"          inv2=inv1*inv1;\n"
"        } else if (lj1[mtype].y == 1) {\n"
"          inv2=r2inv*ucl_sqrt(r2inv);\n"
"          inv1=inv2*inv2;\n"
"        } else {\n"
"          inv1=r2inv*r2inv*r2inv;\n"
"          inv2=inv1;\n"
"        }\n"
"        numtyp force = factor_lj*r2inv*inv1*(lj1[mtype].z*inv2-lj1[mtype].w);\n"
"        f.x+=delx*force;\n"
"        f.y+=dely*force;\n"
"        f.z+=delz*force;\n"
"        if (EVFLAG && eflag)\n"
"          energy += factor_lj*inv1*(lj3[mtype].x*inv2-lj3[mtype].y)-\n"
"                    lj3[mtype].z;\n"
"        if (EVFLAG && vflag) {\n"
"          virial[0] += delx*delx*force;\n"
"          virial[1] += dely*dely*force;\n"
"          virial[2] += delz*delz*force;\n"
"          virial[3] += delx*dely*force;\n"
"          virial[4] += delx*delz*force;\n"
"          virial[5] += dely*delz*force;\n"
"        }\n"
"      }\n"
"    } \n"
"  } \n"
"  store_answers(f,energy,virial,ii,inum,tid,t_per_atom,offset,eflag,vflag,\n"
"                ans,engv);\n"
"}\n"
"__kernel void k_lj_sdk_fast(const __global numtyp4 *restrict x_,\n"
"                            const __global numtyp4 *restrict lj1_in,\n"
"                            const __global numtyp4 *restrict lj3_in,\n"
"                            const __global numtyp *restrict sp_lj_in,\n"
"                            const __global int *dev_nbor,\n"
"                            const __global int *dev_packed,\n"
"                            __global acctyp4 *restrict ans,\n"
"                            __global acctyp *restrict engv,\n"
"                            const int eflag, const int vflag, const int inum,\n"
"                            const int nbor_pitch, const int t_per_atom) {\n"
"  int tid, ii, offset;\n"
"  atom_info(t_per_atom,ii,tid,offset);\n"
"  __local numtyp4 lj1[MAX_SHARED_TYPES*MAX_SHARED_TYPES];\n"
"  __local numtyp4 lj3[MAX_SHARED_TYPES*MAX_SHARED_TYPES];\n"
"  __local numtyp sp_lj[4];\n"
"  int n_stride;\n"
"  local_allocate_store_pair();\n"
"  if (tid<4)\n"
"    sp_lj[tid]=sp_lj_in[tid];\n"
"  if (tid<MAX_SHARED_TYPES*MAX_SHARED_TYPES) {\n"
"    lj1[tid]=lj1_in[tid];\n"
"    if (EVFLAG && eflag)\n"
"      lj3[tid]=lj3_in[tid];\n"
"  }\n"
"  acctyp4 f;\n"
"  f.x=(acctyp)0; f.y=(acctyp)0; f.z=(acctyp)0;\n"
"  acctyp energy, virial[6];\n"
"  if (EVFLAG) {\n"
"    energy=(acctyp)0;\n"
"    for (int i=0; i<6; i++) virial[i]=(acctyp)0;\n"
"  }\n"
"  __syncthreads();\n"
"  if (ii<inum) {\n"
"    int nbor, nbor_end;\n"
"    int i, numj;\n"
"    nbor_info(dev_nbor,dev_packed,nbor_pitch,t_per_atom,ii,offset,i,numj,\n"
"              n_stride,nbor_end,nbor);\n"
"    numtyp4 ix; fetch4(ix,i,pos_tex); \n"
"    int iw=ix.w;\n"
"    int itype=fast_mul((int)MAX_SHARED_TYPES,iw);\n"
"    numtyp factor_lj;\n"
"    for ( ; nbor<nbor_end; nbor+=n_stride) {\n"
"      int j=dev_packed[nbor];\n"
"      factor_lj = sp_lj[sbmask(j)];\n"
"      j &= NEIGHMASK;\n"
"      numtyp4 jx; fetch4(jx,j,pos_tex); \n"
"      int mtype=itype+jx.w;\n"
"      \n"
"      numtyp delx = ix.x-jx.x;\n"
"      numtyp dely = ix.y-jx.y;\n"
"      numtyp delz = ix.z-jx.z;\n"
"      numtyp r2inv = delx*delx+dely*dely+delz*delz;\n"
"      if (r2inv<lj1[mtype].x) {\n"
"        r2inv=ucl_recip(r2inv);\n"
"        numtyp inv1,inv2;\n"
"        if (lj1[mtype].y == (numtyp)2) {\n"
"          inv1=r2inv*r2inv;\n"
"          inv2=inv1*inv1;\n"
"        } else if (lj1[mtype].y == (numtyp)1) {\n"
"          inv2=r2inv*ucl_sqrt(r2inv);\n"
"          inv1=inv2*inv2;\n"
"        } else {\n"
"          inv1=r2inv*r2inv*r2inv;\n"
"          inv2=inv1;\n"
"        }\n"
"        numtyp force = factor_lj*r2inv*inv1*(lj1[mtype].z*inv2-lj1[mtype].w);\n"
"        f.x+=delx*force;\n"
"        f.y+=dely*force;\n"
"        f.z+=delz*force;\n"
"        if (EVFLAG && eflag)\n"
"          energy += factor_lj*inv1*(lj3[mtype].x*inv2-lj3[mtype].y)-\n"
"                    lj3[mtype].z;\n"
"        if (EVFLAG && vflag) {\n"
"          virial[0] += delx*delx*force;\n"
"          virial[1] += dely*dely*force;\n"
"          virial[2] += delz*delz*force;\n"
"          virial[3] += delx*dely*force;\n"
"          virial[4] += delx*delz*force;\n"
"          virial[5] += dely*delz*force;\n"
"        }\n"
"      }\n"
"    } \n"
"  } \n"
"  store_answers(f,energy,virial,ii,inum,tid,t_per_atom,offset,eflag,vflag,\n"
"                ans,engv);\n"
"}\n"
;
